DefaultIteratorAdapter (FreeMarker 2.3.23 API)
Date: 2015-07-05

freemarker.template

## Class DefaultIteratorAdapter

- java.lang.Object
- - freemarker.template.WrappingTemplateModel
  - - freemarker.template.DefaultIteratorAdapter

- All Implemented Interfaces:
    WrapperTemplateModel, AdapterTemplateModel, TemplateCollectionModel, TemplateModel, Serializable

      public class DefaultIteratorAdapter
      extends WrappingTemplateModel
      implements TemplateCollectionModel, AdapterTemplateModel, WrapperTemplateModel, Serializable

  Adapts an `Iterator` to the corresponding `TemplateModel` interface(s), most importantly to `TemplateCollectionModel`. The resulting `TemplateCollectionModel` can only be iterated once.

  Thread safety: A `DefaultListAdapter` is as thread-safe as the array that it wraps is. Normally you only have to consider read-only access, as the FreeMarker template language doesn't allow writing these sequences (though of course, Java methods called from the template can violate this rule).

  This adapter is used by `DefaultObjectWrapper` if its `useAdaptersForCollections` property is `true`, which is the default when its `incompatibleImprovements` property is 2.3.22 or higher.

  Since:
    2.3.22
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface freemarker.template.TemplateModel

      `NOTHING`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DefaultIteratorAdapter` | `adapt(Iterator iterator, ObjectWrapper wrapper)` Factory method for creating new adapter instances.
    `Object` | `getAdaptedObject(Class hint)` Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
    `Object` | `getWrappedObject()` Retrieves the original object wrapped by this model.
    `TemplateModelIterator` | `iterator()` Retrieves a template model iterator that is used to iterate over the elements in this collection.

    - ### Methods inherited from class freemarker.template.WrappingTemplateModel

      `getDefaultObjectWrapper, getObjectWrapper, setDefaultObjectWrapper, setObjectWrapper, wrap`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### adapt

          public static DefaultIteratorAdapter adapt(Iterator iterator,
                                                     ObjectWrapper wrapper)

      Factory method for creating new adapter instances.
      Parameters:
        `iterator` - The iterator to adapt; can't be `null`.

    - #### getWrappedObject

          public Object getWrappedObject()

      Description copied from interface: `WrapperTemplateModel`
      Retrieves the original object wrapped by this model.
      Specified by:
        `getWrappedObject` in interface `WrapperTemplateModel`

    - #### getAdaptedObject

          public Object getAdaptedObject(Class hint)

      Description copied from interface: `AdapterTemplateModel`
      Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
      Specified by:
        `getAdaptedObject` in interface `AdapterTemplateModel`
      Parameters:
        `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
      Returns:
        the underlying object, or its value accommodated for the hint class.

    - #### iterator

          public TemplateModelIterator iterator()
                                         throws TemplateModelException

      Description copied from interface: `TemplateCollectionModel`
      Retrieves a template model iterator that is used to iterate over the elements in this collection.
      Specified by:
        `iterator` in interface `TemplateCollectionModel`
      Throws:
        `TemplateModelException`